type TPOLY=array of record lat,lon:extended; end;
     TPASMO=array of record
       sName: string;
       LatMin,LatMax,LonMin,LonMax: extended;
       poly:TPOLY;
     end;
var aPasma: TPASMO;

procedure TPRead(sFile:string; idx:integer); //nacte jeden polygon ze souboru
var s:string;
    i:integer;
    aList:TStringList;
    f:extended;
begin
  SetLength(aPasma[idx].poly,0);
  s:=RegexSubstitute('.*\\(.*)\.txt',sFile,'$1');
  aPasma[idx].sName:=s;                          //jmeno tarifniho pasma
  aList:=TStringList.Create();
  try
    //Result.LatMin:=9999; Result.LonMin:=9999; Result.LatMax:=-9999; Result.LonMax:=-9999;
    aList.Text:=FileToString(sFile);
    SetLength(aPasma[idx].poly,aList.Count);
    for i:=0 to aList.Count-1 do begin
      s:=aList[i];
      f:=StrToFloat(Fetch(s,','));
      if(aPasma[idx].LatMin>f) then aPasma[idx].LatMin:=f;
      if(aPasma[idx].LatMax<f) then aPasma[idx].LatMax:=f;
      aPasma[idx].poly[i].lat:=f;
      f:=StrToFloat(s);
      if(aPasma[idx].LonMin>f) then aPasma[idx].LonMin:=f;
      if(aPasma[idx].LonMax<f) then aPasma[idx].LonMax:=f;
      aPasma[idx].poly[i].lon:=f;
    end;
  finally
    aList.Free();
  end;
  //zkontrolujeme, zda prvni bod je zaroven poslednim, pokud ne, pridame jej
  i:=Length(aPasma[idx].poly);
  if((aPasma[idx].poly[0]<>aPasma[idx].poly[i-2])
    or (aPasma[idx].poly[1]<>aPasma[idx].poly[i-1])) then begin
    SetLength(aPasma[idx].poly,i+1);
    aPasma[idx].poly[i].lat:=(aPasma[idx].poly[0].lat);
    aPasma[idx].poly[i].lon:=(aPasma[idx].poly[0].lon);
  end;
//{$ifdef DEBUG_HELPER} LDH('Polygon pro tarifni pasmo '+IntToStr(idx)+': pocet bodu: '+IntToStr(i));{$endif}
end;

procedure TPFree;  //uklid
var i:integer;
begin
  for i:=0 to Length(aPasma)-1 do SetLength(aPasma[i].poly,0);
end;

procedure TPInit(sDir:string); //nacte polygony tarifnich pasem
var i:integer;
    aList:TStringList;
    s:string;
begin
  TPFree(); //napred zrusime puvodni nactena pasma
  aList:=TStringList.Create();
  try
    //zjistime seznam souboru s polygony tarifnich pasem
    FileList(sDir, aList);
    //soubory, ktere nemaji priponu .txt vyhodime
    for i:=aList.Count-1 downto 0 do begin
      s:=Copy(aList[i],Length(aList[i])-3,Length(aList[i]));
//{$ifdef DEBUG_HELPER} LDH('Soubor '+aList[i]+' s='+s);{$endif}
      if(s<>'.txt') then aList.Delete(i);
    end;
    SetLength(aPasma,aList.Count);        //nastavime velikost pole pro pasma
    for i:=0 to aList.Count-1 do begin
//{$ifdef DEBUG_HELPER} LDH('Nacitam soubor '+aList[i]);{$endif}
      TPRead({sDir+}aList[i],i);
    end;
  finally
    aList.Free();
  end;
end;

//funkce zjisti, zda bod [lat,lon] je uvnitr polygonu
function InsidePolygon(lat, lon: extended; idx:integer): Boolean;
var  i,len: integer;
     aPoly:TPOLY;
begin
  Result:=false;
  aPoly:=aPasma[idx].poly;
  len:=Length(aPoly);
  if(len<6) then exit;  //prilis maly polygon - je to jen cara.
  //pokud nejsou souradnice v obdelniku opsanem polygonu, nemuze byt uvnitr!
  if(not((lat>=aPasma[idx].LatMin) and (lat<=aPasma[idx].LatMax)
    and (lon>=aPasma[idx].LonMin) and (lon<=aPasma[idx].LonMax))) then exit;
  //testuj, jestli je bod uvnitr polygonu
  for i:=0 to len-2 do begin
    if(((aPoly[i+1].lon<lon) AND (aPoly[i].lon>=lon))
      OR ((aPoly[i].lon<lon) AND (aPoly[i+1].lon>=lon)))
      AND ((aPoly[i+1].lat<=lat) OR (aPoly[i].lat<=lat)) then
      Result:=Result XOR ((aPoly[i+1].lat+(lon-aPoly[i+1].lon) /
        (aPoly[i].lon-aPoly[i+1].lon)*(aPoly[i].lat-aPoly[i+1].lat)<lat));
  end;
  //SetLength(aPoly,0);
end;

function GetTP(lat,lon:string):string; //zjisti tarifni pasmo, do ktereho spadaji souradnice
var i:integer;
begin
  Result:='???';
  for i:=0 to Length(aPasma)-1 do begin
    if(InsidePolygon(StrToFloat(lat),StrToFloat(lon),i)) then begin
      //ze jmena pasma pouzijeme jen jeho cislo (jak to bude u jinych nez Prahy??)
      Result:=RegexSubstitute('.*_(.*)',aPasma[i].sName,'$1');
      //Result:=aPasma[i].sName;
      break;
    end;
  end;
end;

procedure SavePasmo(sDir,sName,sCoords:string);
var sLat,sLon,sTxt:string;
begin
  while(sCoords<>'') do begin
    sLon:=Fetch(sCoords,',');
    sLat:=Fetch(sCoords,',');
    Fetch(sCoords,' '); //zahodime informaci asi o stylu bodu polygonu
    sTxt:=sTxt+sLat+','+sLon+CRLF;
  end;
  if(GGForm_cbRegion.Text='JMK') then StringToFile(sTxt,sDir+'Zona_'+sName+'.txt')
  else StringToFile(sTxt,sDir+'Pasmo_'+sName+'.txt');
end;

procedure ParseXML(Xml:TJclSimpleXML;sDir:string);
var  root,ele,elePl, elePo: TJclSimpleXMLElem;
     n,jF,jPl,jPo: integer;
     sName,sCoords: string;
begin
  { seznam zajimavych TAGu v XML souboru
    Document
      ...
      Folder
        Placemark
          name
          ...
          Polygon
            ...
            outerBoundaryIs
              LinearRing
                coordinates
        Placemark
        ...
    name - jmeno pasma (pro JMK je to cislo)
    coordinates - souradnice bodu polygonu (lon,lat,x pro kazdy bod, prvni a posledni bod jsou totozne)
  }
  try
    //KML soubor ma 2 polozky rootu, zajimava je 2. (Document)
    //ale protoze XML soubor muze mit jen jedinou polozku Root, je posledni
    //nactena namapovana jako jedina
    root:=XML.Root.Items[0];
    for n:=0 to root.Items.count-1 do begin
      ele:=root.Items[n];
      if(ele.name='Folder')then begin
        for jF:=0 to ele.Items.count-1 do begin
          if(ele.Items[jF].name='Placemark') then begin
            elePl:=ele.Items[jF];
            for jPl:=0 to elePl.Items.count-1 do begin
              if(elePl.Items[jPl].name='name') then begin
                sName:=elePl.Items[jPl].Value;
//{$ifdef DEBUG_HELPER} LDH('Placemark: '+sName);{$endif}
              end;
              if(elePl.Items[jPl].name='Polygon') then begin
//{$ifdef DEBUG_HELPER} LDH('Polygon');{$endif}
                elePo:=elePl.Items[jPl];
                for jPo:=0 to elePo.Items.count-1 do begin
                  if(elePo.Items[jPo].name='outerBoundaryIs') then begin
//{$ifdef DEBUG_HELPER} LDH('outerBoundary');{$endif}
                    sCoords:=elePo.Items[jPo].Items[0].Items[0].Value;
                    //ulozime souradnice (na zacatku jsou tabulatory) do souboru
                    sCoords:=Trim(ReplaceString(sCoords,Chr(9),''));
//{$ifdef DEBUG_HELPER} LDH('Pasmo '+sName+': '+sCoords);{$endif}
                    SavePasmo(sDir,sName,sCoords);
                  end;
                end;
              end; //if polygon
            end;
          end; //if placemark
        end;
      end; //folder
    end;  //for n:=0
  finally ;
  end;  //try
end;

procedure PasmaKmlToTxt(sDir:string);      //vytvori soubory s polygony pasem
var s,sKml:string;
    aList:TStringList;
    i:integer;
    Xml:TJclSimpleXML;
begin
  //podle jmena regionu zjistit jediny kml soubor v adresari s pasmy
  //vymaze *.txt soubory a podle *.kml je vytvori znovu
  DeleteFiles(sDir+'*.txt'); //smazeme stare soubory
  aList:=TStringList.Create();
  try
    FileList(sDir,aList);
    for i:=aList.Count-1 downto 0 do begin
      s:=Copy(aList[i],Length(aList[i])-3,Length(aList[i]));
//{$ifdef DEBUG_HELPER} LDH('Soubor '+aList[i]+' s='+s);{$endif}
      if(s<>'.kml') then aList.Delete(i);
    end;
    if(aList.Count>1) then ShowMessage('ERR: v adresari '+sDir+CRLF
      +'je vice *.kml souboru a neni tedy jasne, z ktereho ziskat polygony.')
    else if(aList.Count<1) then ShowMessage('ERR: v adresari '+sDir+CRLF
      +'neni zadny *.kml soubor, z ktereho ziskat polygony.')
    else sKml:=aList[0];
  finally
    aList.Free();
  end;
  if(sKml='') then exit;
  Xml:=TJclSimpleXML.Create();
  try
{$ifdef DEBUG_HELPER} LDH('Nacteni KLM souboru: '+sKml);{$endif}
    Xml.loadfromfile(sKml,seAuto,0);
{$ifdef DEBUG_HELPER} LDH('Parsovani KLM souboru');{$endif}
    ParseXML(Xml,sDir);
  finally
    Xml.Free();
  end;
end;